#!/usr/bin/env python
	
# Album Cover Plugin code changed for kiba pleasure
# Menu Code from Menu QL Plugin
# Shamelessly Modified By: sandi.newton
# Original Copyright 2005 Joe Wreschnig,Licensed under GPL

import gtk
import stock
import sys
import pango
import dbus
import time
import gobject
from commands import getoutput
from atexit import register


import const
import util
import qltk
import shutil
import config
import browsers
from player import playlist as player
from widgets import main as window, watcher
from plugins.events import EventPlugin
from qltk.browser import LibraryBrowser
from qltk.controls import StopAfterMenu
from qltk.information import Information
from qltk.properties import SongProperties

kiba_bus = None
out = "/tmp/current.jpg"
no_cd = "/usr/share/quodlibet/missing-cover.svg"
ICON_NAME = "quod-cover"
running = 0
menu = None
def resetpic():
	global kiba_bus
	if kiba_bus:
		try:
			kiba_bus.RemoveObject(ICON_NAME)
		except:
			pass

class PictureSaver(EventPlugin):
    PLUGIN_ID = "Album Art Display in Kiba Dock"
    PLUGIN_NAME = _("Album Art Display")
    PLUGIN_DESC = "The cover image is shown in Kiba dock "
    PLUGIN_VERSION = "0.2"
    
    def __init__(self):
	global kiba_bus
	global running
	bus = dbus.SessionBus()
	obj = bus.get_object("org.kiba.dock.Kiba","/org/kiba/dock/Kiba")
	kiba_bus = dbus.Interface(obj, "org.kiba.dock.Kiba")
	kiba_bus.TryLauncherIconFromClass(ICON_NAME,"quodlibet")
	register(resetpic)

	bus.add_signal_receiver(self.open_handler, dbus_interface = "org.kiba.dock.Kiba", signal_name = "Initialled")
	if getoutput("pidof kiba-dock"):
		running = 1
	bus.add_signal_receiver(self.close_handler, dbus_interface = "org.kiba.dock.Kiba", signal_name = "Closed")
	bus.add_signal_receiver(self.context_menu, dbus_interface = "org.kiba.dock.Kiba", signal_name = "IconMenu")
	bus.add_signal_receiver(self.button_release, dbus_interface = "org.kiba.dock.Kiba", signal_name = "IconReleased")

    def open_handler(self):
	global running
	running = 1

    def close_handler(self):
	global running
	running = 0

    def properties(self,watcher,player):
	if player.song:
		SongProperties(watcher,[player.song])

    def information(self,watcher,player):
	if player.song:
		Information(watcher,[player.song])
    def set_active(self,widget):
	#print widget.get_active()
	window.repeat.set_active(widget.get_active()) 
    def create_menu(self):
        playpause = gtk.ImageMenuItem(gtk.STOCK_MEDIA_PLAY)
	stocker = [gtk.STOCK_MEDIA_PAUSE,gtk.STOCK_MEDIA_PLAY][player.paused]
	img = gtk.image_new_from_stock(stocker,gtk.ICON_SIZE_MENU)
	playpause.set_image(img)
	playpause.child.set_text(gtk.stock_lookup(stocker)[1])
	playpause.child.set_use_underline(True)

        playpause.connect('activate', self.play_pause, player)
       # safter = StopAfterMenu(player)
       # playpause.connect(
       #     'button-press-event', self.play_pause_button, safter)

        previous = gtk.ImageMenuItem(gtk.STOCK_MEDIA_PREVIOUS)
        previous.connect('activate', self.prev)
        next = gtk.ImageMenuItem(gtk.STOCK_MEDIA_NEXT)
        next.connect('activate', self.next)

        orders = gtk.MenuItem(_("Play _Order"))
        submenu = gtk.Menu()
        repeat = gtk.CheckMenuItem(_("_Repeat"))
	repeat.connect(
            'toggled', self.set_active)#lambda s: window.repeat.set_active(s.get_active()))
        submenu.append(repeat)
        submenu.append(gtk.SeparatorMenuItem())
        items = [None]
        def set_order(widget, num):
            if widget.get_active(): window.order.set_active(num)
        for i, s in enumerate(
            [_("_In Order"), _("_Shuffle"), _("_Weighted"), _("_One Song")]):
            items.append(gtk.RadioMenuItem(items[-1], s))
            items[-1].connect('toggled', set_order, i)
        items.remove(None)
        map(submenu.append, items)
        #orders.set_submenu(submenu)

        #browse = qltk.MenuItem(_("_Browse Library"), gtk.STOCK_FIND)
        m2 = gtk.Menu()
        from library import library
        for Kind in browsers.browsers:
            o = gtk.MenuItem(Kind.accelerated_name)
            o.connect_object('activate', LibraryBrowser, Kind, library)
            m2.append(o)
        #browse.set_submenu(m2)

        props = gtk.ImageMenuItem(stock.EDIT_TAGS)
        props.connect_object('activate', self.properties, watcher, player)

        info = gtk.ImageMenuItem(gtk.STOCK_INFO)
        info.connect_object('activate', self.information, watcher, player)

        rating = gtk.Menu()
        def set_rating(value):
            song = player.song
            if song is None: return
            else:
                song["~#rating"] = value
                watcher.changed([song])
        for i in range(0, int(1.0/util.RATING_PRECISION)+1):
            j = i * util.RATING_PRECISION
            item = gtk.MenuItem("%0.2f\t%s" % (j, util.format_rating(j)))
            item.connect_object('activate', set_rating, j)
            rating.append(item)
        ratings = gtk.MenuItem(_("_Rating"))
        #ratings.set_submenu(rating)

        quit = gtk.ImageMenuItem(gtk.STOCK_QUIT)
        quit.connect('activate', gtk.main_quit)

        menu = gtk.Menu()
        for item in [playpause,
                     gtk.SeparatorMenuItem(), previous, next, 
                     gtk.SeparatorMenuItem(), props, info,
                     gtk.SeparatorMenuItem(), quit]:
            menu.append(item)
        menu.repeat = repeat
        menu.orders = items
        menu.sensitives = [props, next, info]
        #safter.connect_object('selection-done', gtk.Menu.popdown, menu)
	return menu

    def prev(self,*args):
	player.previous()	

    def next(self,*args):
	player.next()

    def play_pause(self,*args):
	if player.song:
		player.paused ^= True
	else:
		player.reset()
	if(menu):
		playpause = menu.get_children()[0]
		stock = [gtk.STOCK_MEDIA_PAUSE, gtk.STOCK_MEDIA_PLAY][player.paused]
		img = gtk.image_new_from_stock(stock, gtk.ICON_SIZE_MENU)
		playpause.set_image(img)
		playpause.child.set_text(gtk.stock_lookup(stock)[1])
		playpause.child.set_use_underline(True)
    
    def play_pause_button(self,activator,event,safter):
	if event.button == 3:
		safter.popup(None, None, None, event.button, event.time)
		return True	

    def exit(self,*args):
	import sys
	sys.exit(1)
    def show_menu(self):
	global menu
	menu = self.create_menu()	
	menu.show_all()
	order = window.order.get_active()
	menu.orders[order].set_active(True)
	menu.repeat.set_active(window.repeat.get_active())
	menu.popup(None,None,None,3,0,0)
	return 0

    def button_release(self,id):
	if id != ICON_NAME:
		return
#	try: window.move(*window.__position)
#	except AttributeError: pass
	if not config.getboolean('plugins',"icon_window_visible"): 
		window.present()
		config.set("plugins", "icon_window_visible", "true")
	else: 
		window.__position = window.get_position()
		window.hide()
		config.set("plugins", "icon_window_visible", "false")

    def context_menu(self,id):
	if id != ICON_NAME:
		return
	gobject.timeout_add(250, self.show_menu);

    def current_time_display(self):
	current = player.get_position()/1000
	total =  player.song["~#length"]
	if running:
		kiba_bus.ProgressSetValue(ICON_NAME,100*current/total)
	return 1
    def plugin_on_paused(self):
	global menu
	if(menu):
	        playpause = menu.get_children()[0]
	        stock = [gtk.STOCK_MEDIA_PAUSE, gtk.STOCK_MEDIA_PLAY][player.paused]
	        img = gtk.image_new_from_stock(stock, gtk.ICON_SIZE_MENU)
	        playpause.set_image(img)
	        playpause.child.set_text(gtk.stock_lookup(stock)[1])
	        playpause.child.set_use_underline(True)
    plugin_on_unpaused = plugin_on_paused

    def plugin_on_song_started(self, song):
	global kiba_bus
	if song is None:
		if running:
			try:
				#print "No Song",time.time()
				kiba_bus.SetIcon(ICON_NAME,no_cd)
			except dbus.DBusException,e:
				if e.__str__() == "No Object Found":
					kiba_bus.TryLauncherIconFromClass(ICON_NAME,"quodlibet") 
				pass
        else:
            gobject.timeout_add(1000, self.current_time_display)
            song_name = player.song["artist"] + " - " + player.song["album"] + " - " + player.song["title"]
            kiba_bus.SetTitel(ICON_NAME, song_name)
            cover = song.find_cover()
            if cover is None:
		if running:
			try:
				#print "No Cover",time.time()
				kiba_bus.SetIcon(ICON_NAME,no_cd)
			except dbus.DBusException,e:
				if e.__str__() == "No Object Found":
					kiba_bus.TryLauncherIconFromClass(ICON_NAME,"quodlibet") 
				pass	
            else:
		f = file(out, "wb")
		f.write(cover.read())
		f.close()
		if running:
			try:
				#print "Changed",time.time()
				kiba_bus.SetIcon(ICON_NAME,"")
				kiba_bus.SetIcon(ICON_NAME,out)
			except dbus.DBusException,e:
				if e.__str__() == "No Object Found":
					kiba_bus.TryLauncherIconFromClass(ICON_NAME,"quodlibet")
				pass
    def disabled(self):
	resetpic()

    def window_delete(self,window,event):
	window.__position = window.get_position()
        window.hide()
        config.set("plugins", "icon_window_visible", "false")
	return True

    def enabled(self):
	global kiba_bus
	window.connect('delete-event', self.window_delete)
	if running:
		try:
			kiba_bus.AddObject(ICON_NAME,"quodlibet","quodlibet") 
		except:
			pass	
    def destroy(self):
	resetpic()
